﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// UserControl1.xaml 的交互逻辑
    /// </summary>
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();
            List<Tuple<string, string, string>> tupes = new List<Tuple<string, string, string>>();
            Enumerable.Range(1, 10).Select(p => p.ToString().PadLeft(3, '0')).ToList().ForEach(p => tupes.Add(new Tuple<string, string, string>(p, p, p)));
            listboxSuggestion.ItemsSource = tupes;
            listboxSuggestion.SelectionChanged += (o1, e1) =>
            {
                //this.IsDropDownOpen = false;      //加不加上没有效果
                RoutedEventArgs args = new RoutedEventArgs(EnterDownEvent, o1); //选中项改变触发
                this.RaiseEvent(args);
            };            
        }

        #region 回车触发事件
        //声明和注册路由事件
        public static readonly RoutedEvent EnterDownEvent =
            EventManager.RegisterRoutedEvent(
                "EnterDown",
                RoutingStrategy.Bubble,
                typeof(EventHandler<RoutedEventArgs>),
                typeof(UserControl1));
        //CLR事件包装
        public event RoutedEventHandler EnterDown
        {
            add { this.AddHandler(EnterDownEvent, value); }
            remove { this.RemoveHandler(EnterDownEvent, value); }
        }
        #endregion

        #region 是否打开下拉框
        public bool IsDropDownOpen
        {
            get { return (bool)GetValue(IsDropDownOpenProperty); }
            set
            {

                SetValue(IsDropDownOpenProperty, value);

            }
        }
        public static readonly DependencyProperty IsDropDownOpenProperty =
            DependencyProperty.Register("IsDropDownOpen", typeof(bool), typeof(UserControl1), new PropertyMetadata(false));
        #endregion
    }
}
